package person;

public class Author {
	private String lastName;
	private String firstName;

	private Author(String lastName, String firstName) {
		this.lastName  = new String(lastName);
		this.firstName = new String(firstName);
	}

	public static Author make(String input) {
		String lastName;
		String firstName;

		// "   Kovács      János   "               -> lastName = "Kovács", firstName = "János"
		// "   Kovács      János   ".trim()        -> "Kovács      János"
		// "   Kovács      János   ".split("\\s+") -> { "Kovács", "János" }

		String[] x = input.trim().split("\\s+");

		lastName  = x[0];
		firstName = x[1];

	        /*	
		String x[] = input.trim().split(" ");

		int nonEmpties = 0;

		for (String s : x) {
			if (!s.isEmpty()) nonEmpties += 1;
		}

		if (nonEmpties != 2)
			return null;

		String y[] = new String[nonEmpties];

		for (int i = 0, j = 0; i < x.length; i++) {
			if (!x[i].isEmpty()) {
				y[j] = x[i];
				j += 1;
			}
		}

		lastName  = y[0];
		firstName = y[1];
		*/

		if (Character.isUpperCase(lastName.charAt(0)) &&
		    Character.isUpperCase(firstName.charAt(0)) ) {
			return new Author(lastName, firstName);
		}

		return null;
	}

	public String getLastName() {
		return new String(lastName);
	}

	public String getFirstName() {
		return new String(firstName);
	}

	public String toString() {
		return (lastName + ", " + firstName);
	}

	public boolean equalsTo(Author other) {
		return (lastName.equals(other.lastName) && firstName.equals(other.firstName));
	}

	public Author copy() {
		return (new Author(this.lastName, this.firstName));
	}
}
