import java.io.*;

class File1 {
    
    //Olvassuk be a megadott fajl tartalmat es irjuk ki a konzolra
    static void printFile(String filePath) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(filePath)));
        
        for (String line = reader.readLine(); line != null; line = reader.readLine()) {
            System.out.println(line);
        }
        
        reader.close();
    }
    
    //Irjuk ki, ha a file valamelyik sora teljesen megegyezik a megadott szoveggel
    static boolean findLine(String lineToFind, String filePath) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(filePath)));
        int lineNum = 0;
        
        for (String line = reader.readLine(); line != null; line = reader.readLine()) {
            lineNum++;
            if (line.equals(lineToFind)) {
                System.out.println("A keresett kifejezes a " + lineNum + ". sorral egyezik meg.");
                return true;
            }
        }
        
        return false;
    }
    
    //Irjuk ki, ha a file valamelyik sora tartalmazza a megadott szoveget
    static boolean findText(String textToFind, String filePath) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(filePath)));
        int lineNum = 0;
        
        for (String line = reader.readLine(); line != null; line = reader.readLine()) {
            lineNum++;
            
            if (line.contains(textToFind)) {
                System.out.println("A keresett kifejezes a " + lineNum + ". sorban talalhato.");
                return true;
            }
        }
        
        return false;
    }
    
    public static void main(String[] args) {
        String fileName = args[0];
        
        try {
            System.out.println();
            printFile(fileName);
            System.out.println();
            
            System.out.println("Add meg a keresendo szoveget!");
            String text = System.console().readLine();
            
            findLine(text, fileName);
            findText(text, fileName);
        } catch(FileNotFoundException e) {
            System.err.println("A(z) " + fileName + " fajl nem talalhato.");
        } catch(IOException e) {
            System.err.println("Olvasasi hiba.");
        }
    }
}
