import java.io.*;
import java.util.*;

class File2 {
    
    //Olvassuk be a megadott fajl tartalmat es irjuk ki a konzolra
    static void printFile(String filePath) throws FileNotFoundException {
        Scanner sc = new Scanner(new File(filePath));
        
        while (sc.hasNextLine()) {
            System.out.println(sc.nextLine());
        }
        
        sc.close();
    }
    
    //a file minden sora vesszovel elvalasztott szamokat tartalmaz; soronkent adjuk ossze oket
    static List<Integer> process(String filePath) throws FileNotFoundException {
        List<Integer> list = new ArrayList<Integer>();
        Scanner sc = new Scanner(new File(filePath));
        
        while (sc.hasNextLine()) {
            int sum = 0;
            Scanner scLine = new Scanner(sc.nextLine());
            scLine.useDelimiter(",");
            
            //ha feltesszuk, hogy a fajl formatuma helyes
            while (scLine.hasNext()) {
                sum += scLine.nextInt();
            }
            
            /*
            //ha hibas adatok is lehetnek, 1. valtozat
            while (scLine.hasNext()) {
                if (scLine.hasNextInt())
                    sum += scLine.nextInt();
                else
                    scLine.next();
            }
            */
            
            /*
            //ha hibas adatok is lehetnek, 2. valtozat
            while (scLine.hasNext()) {
                try {
                    sum += scLine.nextInt();
                } catch (InputMismatchException e) {
                    scLine.next();
                }
            }
            */
            
            /*
            //ha hibas adatok is lehetnek, 3. valtozat
            while (scLine.hasNext()) {
                try {
                    sum += Integer.parseInt(scLine.next());
                } catch (NumberFormatException e) { }
            }
            */
            
            list.add(sum);
        }
        
        sc.close();
        return list;
    }
        
    public static void main(String[] args) {
        String fileName = args[0];
        
        try {
            System.out.println();
            printFile(fileName);
            System.out.println();
            
            System.out.println("A feldolgozas eredmenye: " + process(fileName));
        } catch(FileNotFoundException e) {
            System.err.println("A(z) " + fileName + " fajl nem talalhato.");
        }
    }
}
