# Java Server Pages #

Szerveroldali Java (ez az, ahol a Java ers).

Kis trtneti ttekints:
* gohper://
* Statikus HTML
* Dinamikus HTML, CGI (elkezdtk arra hasznlni, amire nem val)
* Szerver oldali scriptels (PHP/MySQL)

	```php
	<html>
	 <head>
	  <title>PHP Test</title>
	 </head>
	 <body>
	 <? echo '<p>Hello World</p>'; ?> 
	 </body>
	</html>
	```

* j: mindenhol JS...

## Elzmny: Szervletek ##

* [JSR 315](http://www.jcp.org/en/jsr/detail?id=315) - Servlet 3.0 (aktulis, 2009 ta)
* [JSR 154](http://www.jcp.org/en/jsr/detail?id=154) - Servlet 2.4/2.5
* [JSR 53](http://www.jcp.org/en/jsr/detail?id=53) - Servlet 2.3

Java szervlet implementci --> Mgik --> Mg tbb mgik --> Dinamikusan ellltott weboldal

``` java
package hello;
 
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
 
public class HelloServlet extends HttpServlet {
 
    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        getServletContext().log("init()");
    }
 
    @Override
    protected void service(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        getServletContext().log("service()");
        response.getWriter().write("Hello World!");
    }
 
    @Override
    public void destroy() {
        getServletContext().log("destroy()");
    }
}

```

## Ugyanez JSP formtumban ###

``` jsp
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>JSP Page</title>
    </head>
    <body>
        <%
            getServletContext().log("service()");
            response.getWriter().write("Hello World!");
        %>
    </body>
</html>
```

Ebbl generldok egy ehhez hasonl szervlet:

``` java
package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;

public final class FirstJsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

  private static final JspFactory _jspxFactory = JspFactory.getDefaultFactory();

  private static java.util.Vector _jspx_dependants;

  private org.apache.jasper.runtime.ResourceInjector _jspx_resourceInjector;

  public Object getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;

    try {
      response.setContentType("text/html;charset=UTF-8");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;
      _jspx_resourceInjector = (org.apache.jasper.runtime.ResourceInjector) application.getAttribute("com.sun.appserv.jsp.resource.injector");

      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n");
      out.write("   \"http://www.w3.org/TR/html4/loose.dtd\">\n");
      out.write("\n");
      out.write("<html>\n");
      out.write("    <head>\n");
      out.write("        <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n");
      out.write("        <title>JSP Page</title>\n");
      out.write("    </head>\n");
      out.write("    <body>\n");
      out.write("        ");

            getServletContext().log("service()");
            response.getWriter().write("Hello World!");
        
      out.write("\n");
      out.write("    </body>\n");
      out.write("</html>\n");
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
```

### Egyb formtumok ####

* Expression:
	
	``` java
	<%= new java.util.Date() %>
	```	

* Scriplet
	
	``` java
	<%
		out.println(new java.util.Date());
	%>
	```

* Deklarcik:

	``` java
	<%!
	    final Date creationDate = new Date();
	    public Date getDate() {
		return creationDate;
	    }
	%>
	```

* Import utastsok:

	``` java
	<%@ page import="java.util.*" %>
	<html>
	...
	</html>
	```

* Tag-ek:

	``` java
	<jsp:include page="header.jsp"/>
	```

* HTML s JSP utastsok vegytse:

	```java
	<%
	    String name = (String)request.getParameter("name");
	    if ( name != null ) {
	%>
		Hi <%= name %>!
	<%
	    } else {
	%>
		Hi Anonymous!
	<%
	    }
	%>
	```

### Elrhet objektumok ###

* `HttpServletResponse response`: content type belltsa, `Writer`, cookie-k belltsa, session, ezen keresztl rhet el, etc.
* `HttpServletRequest request`: paramterek, session, cookie-k lekrdezse
* `session`: Adott munkamenethez llapotok belltsa (pl. username, bejelentkezs tnye, etc. - ami minden lekrdezsnl j, ha elrjk)

Rgen: doGet() / doPost()

## Szerverek? ##

* Szervlet-kontnerek (+JSP/JSTL)
* App. szerver: teljes J2EE stack (szervletek + EJB, JMS, CDI, JTA, etc.)

Tonnnyi vltozat: Tomcat (referencia, jtk), Geronimo (Apache), GlassFish (Oracle, open source), JBoss (full EE stack, open source), Jetty (miniml, embedded), WebLogic (a tough guy), ...

## Feladatok ##

1. Keressetek egy weboldalt, ami Java-alapon zemel!
2. Vlasszatok egy tetszleges szerveralkalmazst (pl. Tomcat), tltstek le, lltstok be (`README`!), indtstok el.
3. rjatok egy egyszer JSP oldalt, amely 
4. Trkpezztek fel a pldkat, krnyezetet!

## JSP Feladatok ##

1. Kszts egy egyszer JSP oldalt, amely egy minimlis formon keresztl kpes a sessionben idzeteket trolni. Az oldal mindig rja ki az elejn a sessionhz tartoz azonostt, azt, hogy jonnan ltrehozott-e, a ltrehozsnak dtumt, elrsnek utols dtumt, valamnint az eddig trolt idzetek listjt egy felsorolsban.
2. Kszts egy egyszer JSP oldalt, amely minden informcit kir egy tblzatban a klinesrl, ezt praktikusan a `request` objektumon keresztl rheted el. Amit mindenkpp rjon ki az alkalmazs: a lekrdezs mdjt (`GET`/`POST`), a lekrdezs URI s URL cmt, a context path rtkt, a path informcit, a kapott *query stringet*, s az azonostsi mdot (*auth type*).

