# Segdanyagok#

* Az elads anyagai letlthetk az albbi linken: [xxx.tgz][scala-ea]
* Fejlesztkrnyezet letltse
  * Scala IDE, valamint a szksges Java futtatkrnyezet egyben letlthet az albbi linken: [xxx.tgz][scala-ide]
  * A fejlesztkrnyezetrl tovbbi informci az albbi oldalon tallhat: http://scala-ide.org/
* Scala weboldala: http://www.scala-lang.org/
* Kzssgi Scala dokumentcis project (tutorialok, Scala Improvement Process, Language Specification, stb.): http://docs.scala-lang.org/
* Scaladoc online bngszhet, legfrissebb vltozata: http://www.scala-lang.org/api/current/index.html

* Ajnlott olvasmnyok (igyenesen elrhet knyvek):
  * Joshua D. Suereth: [Scala in Depth][scala-in-depth]
  * Cay S. Horstmann: [Scala for the Impatient][scala-impatient]
  * Dean Wampler, Alex Payne: [Programming Scala][oreilly-scala]

# Feladatok #

Megjegyzsek:

* Az albbi feladatok fknt [Phil Gold][phil]: [S-99 - Ninety-Nine Scala Problems][s99] rsn alapszanak, amely valjban Werner Hett (Berne University of Applied Sciences) [Ninety-Nine Prolog Problems][p99] mvnek egy adaptcija. Ha a feladatok tl nehezek, knnyek, esetleg kevsb izgalmasak, a fenti oldalakon bven tallhatk alternatvk.

## Knnyebb feladatok ##

Az albbiakban egyszerbb feladatok tallhatk, amelyek nagyjbl 15-20 perc alatt megoldhatk. Az els feladatoknl mg konkrt szignatrt is megadunk, ksbb azonban ezt fokozatosan elhagyjuk, ezt is nektek kell helyesen megrnotok.

### Lista utols elemnek meghatrozsa ###

Kszts egy fggvnyt a kvetkez szignatrval:

```scala
def last[A](ls: List[A]): A
```

Plda a hasznlatra:

```scala
scala> last(List(1, 1, 2, 3, 5, 8))
res0: Int = 8
```

A megvalstshoz ne a beptett fggvnyt hasznld, hanem prbld a `match`, `::` opertor s res lista (`Nil`) segtsgvel megoldani a feladatot!

### Lista vgtl szmtott N. elem meghatrozsa ###

Kszts egy fggvnyt a kvetkez szignatrval:

```scala
def lastNth[A](n: Int, ls: List[A]): A
```

Plda a hasznlatra:

```scala
scala> lastNth(2, List(1, 1, 2, 3, 5, 8))
res0: Int = 5
```

A megvalstshoz ne a beptett fggvnyt hasznld, hanem adj egy rekurzv algoritmust r!

### Lista hossznak meghatrozsa ###

Kszts egy fggvnyt a kvetkez szignatrval:

```scala
def length[A](ls: List[A]): Int
```

Plda a hasznlatra:

```scala
scala> length(List(1, 3, 5, 7))
res0: Int = 4
```

A megvalstshoz ne a beptett fggvnyt hasznld, hanem vagy kszts egy vgzds szerinti rekurzit (*tail recursion*), vagy hasznld valamely `fold()` fggvnyt!

### Stringek nagybetss alaktsa ###

Kszts egy fggvnyt, amely tetszleges szm String paramtert elfogad (*nem listt!*), s minden paramtert nagybetss alakt!

A fggvnyt tedd egy megfelel `object` definciba, valamint hasznld a megoldshoz a `_` alaprtelmezett paramterjellst!

Plda a hasznlatra:

```scala
scala> Upper.upper("A", "First", "Scala", "Program"))
res0: Array(A, FIRST, SCALA, PROGRAM)
```

### String lista sszefzse egyetlen karakterlncc ###

Kszts egy fggvnyt a kvetkez szignatrval:

```scala
def joiner(strings: List[String], separator: String): String
```

A separator paramter alaprtelmezett rtkkel is rendelkezzen, ez legyen a szkz karakter (*ehhez a megadott szignatrt is mdosthatod, ha szksges*)!

Plda a hasznlatra:

```scala
scala> joiner(List("Programming", "Scala"))
res0: String = "Programming Scala"
```

### Stringek prostsa a hosszukkal ###

Kszts egy fggvnyt a kvetkez szignatrval, amely egy String listhoz visszaad olyan prokat, amelyek tartalmazzk az adott Stringet valamint annak a hozsszt:

```scala
def sizes(ls: List[String]): List[(Int, String)]
```

Plda a hasznlatra:

```scala
scala> sizes(List("a", "bc", "def"))
res0: List[(Int, String)] = List((1,a), (2,bc), (3,def))
```

### Folding ###

Ksztsd el a kvetkez fggvnyek definciit, amelyekhez hasznld valamelyik `fold()` fggvnyt!

```scala
// Elemek osszege
def sum(list: List[Int]): Int

// Elemek szorzata
def product(list: List[Int]): Int

// Elemek szama
def count(list: List[Any]): Int

// Elemek atlaga
def average(list: List[Double]): Double
```

### Reducing ###

Ksztsd el a kvetkez fggvnyek definciit, amelyekhez hasznld valamelyik `reduce()` fggvnyt!

```scala
// Legkisebb elem meghatarozasa
scala> minOf(List(1,2,3))
res0: Int = 1

// Legnagyobb elem meghatarozasa
scala> maxOf(List(1,2,3))
res0: Int = 3
```

## Kzepesen nehz feladatok ##

Az albbi feladatok mr kicsit bonyolultabbak, az elads anyagnak aktv tanulmnyozsa szksges a megoldsukhoz.

### Companion objektumok ###

Kszts egy egyszer `Pair` osztlydefincit, amely String prok ellltsra alkalmazhat! Ennek egyetlen fggvnye legyen:

```scala
def value(): String
```

Amely egy `new Pair("key", "value")` esetn adja vissza a `"key = value"` karakterlncot!

Kszts tovbb egy *companion objektumot* is az osztlydefincihoz, amely tegye lehetv a kvetkez hasznlatot:

```scala
val p = Pair("a", "b") // Nota bene: Nem szerepel 'new' operator!
```

### Karakterkombincik ellltsa ###

Kszts egy olyan fggvnyt, amely a megadott String karaktereinek minden lehetsges permutcijt ellltja!

Plda a hasznlatra:

```scala
scala> perm("abc")
res0: List[String] = List("abc", "acb", "bac", "bca", "cab", "cba")
```

### Egybegyazott listk kiegyenestse ###

```scala
scala> flatten(List(List(1, 1), 2, List(3, List(5, 8))))
res0: List[Any] = List(1, 1, 2, 3, 5, 8)
```

A megvalstshoz hasznld a `flatMap()` fggvnyt!

### Euklideszi algoritmus ###

```scala
scala> gcd(36, 63)
res0: Int = 9
```

A megvalstshoz hasznld az euklideszi algoritmust!

### Relatv prmek ###

Dntsk el kt szmrl, hogy relatv prmek-e!

```scala
scala> 35.isCoprimeTo(64)
res0: Boolean = true
```

**Megjegyzs** Vegyk szre, hogy a fggvnyt a fenti mdon egy tetszleges szmon hvjuk!

### Mintailleszts regulris kifejezsekkel ###

Legyen adott a kvetkez lista definci:

```scala
val catalog = List(
  "Book: title=Programming Scala, authors=Dean Wampler, Alex Payne",
  "Magazine: title=The New Yorker, issue=January 2009",
  "Book: title=War and Peace, authors=Leo Tolstoy",
  "Magazine: title=The Atlantic, issue=February 2009",
  "BadData: text=Who put this here??"
)
```

A lista bejrsa sorn rjuk ki a kpernyre minden knyv (s csak azok!) cmt, valamint rjt (de csak azokat!). A megoldshoz hasznljunk mintaillesztst regulris kifejezsekre!

### Kdols ###

Ksztsnk egy nagyon egyszer monoalfabetikus (egy karaktert mindig ugyanazzal a msik karakterrel helyettest) kdol rendszert, amelyet maga Caesar is hasznlt! A kdols lnyege, hogy minden karaktert a tle hrom karakterrel jobbra szereplvel brzolunk.

Plda:

```scala
scala> encode("Alea iacta est")
res0: String="dohd ldfwd hvw"
```

Kdols eltt minden karaktert alaktsunk kisbetss, valamint elg csupn az angol ABC karaktereivel foglalkozni!

Rszletek a kdols trtnetrl a [Wikipdiban][caesar].

## Nehz feladatok ##

Az albbi feladatok mr esetleg nmi utnajrst vagy komolyabb gondolkodni valt jelentenek.

### Java knyvtrak hasznlata ###

Tltsd le az [iText][itext] knyvtrat, amely egy standard Java knyvtr. Hasznld az API-t Scalabl, s kszts egy egyszer PDF formtum fjlt a segtsgvel!

Egy egyszer [tutorial][itext-tutorial], amely a hasznlatot mutatja.

A program a ksztett PDF tartalmt olvassa egy fjlbl!

### A lovag tja ###

Adott egy `NxN` mret sakktbla. Ltezik-e olyan lpssorozat, amely sorn egy l bbval minden sakktbla mezt rinthetnk egy megadott kezdpontrl indulva?

**Tovbbfejlesztsi lehetsg** Ltezik-e ugyanilyen *zrt t* (zrt t egy olyan t, amely sorn az utols lpsben visszatrnk a kezdpozcira)?

Rszletek a problmrl [Wikipdiban][knights-tour].

### Google Code Jam feladatok ###

Ha kicsit izgalmasabb feladatokat szeretnl, az albbi weboldalon [a hivatalos Google Code Jam selejtez feladatait][code-jam] is megprblhatod ;-)

  [scala-ea]:        http://
  [scala-ide]:       http://...
  [oreilly-scala]:   http://ofps.oreilly.com/titles/9780596155957/
  [scala-impatient]: http://typesafe.com/resources/scala-for-the-impatient
  [scala-in-depth]:  http://typesafe.com/resources/scala-in-depth
  [phil]:            http://aperiodic.net/phil/
  [p99]:             https://prof.ti.bfh.ch/hew1/informatik3/prolog/p-99/
  [s99]:             http://aperiodic.net/phil/scala/s-99/
  [caesar]:          http://en.wikipedia.org/wiki/Caesar_cipher
  [itext]:           http://itextpdf.com
  [itext-tutorial]:  http://itextpdf.com/examples/iia.php?id=12
  [knights-tour]:    http://en.wikipedia.org/wiki/Knight's_tour
  [code-jam]:        http://code.google.com/codejam/contest/1460488/dashboard

