import polyhedra.Prism;
import polyhedra.Cylinder;
import polyhedra.Cube;
import java.util.Comparator;
import java.util.Collections;
import java.util.List;
import java.util.ArrayList;

class PrismByVolume implements Comparator<Prism> {
    public int compare(Prism p1, Prism p2) {
        return (int) (p1.volume() -  p2.volume());
    }

    public boolean equals(Object o) {
      return (o instanceof PrismByVolume);
    }
}

public class PrismApp {
    private static void printVolume(Prism p) {
        System.out.println(p.volume());
    }

    public static void main(String[] args) {
        Prism p = new Cylinder(1.11, 2.222);
        printVolume(p);
        System.out.println(p);
        Cylinder c = new Cylinder(1.11, 2.222);
        printVolume(c);
        System.out.println(c);
        Cube k = new Cube(5.23);
        printVolume(k);
        System.out.println(k);

        List<Prism> list = new ArrayList<Prism>();
        list.add(k);
        list.add(p);
        list.add(c);

        System.out.println("list = " + list);
        Collections.sort(list);
        System.out.println("list = " + list);
        Collections.sort(list, Collections.reverseOrder(new PrismByVolume()));
        System.out.println("list = " + list);		
    }
}
