package lambda;
import java.util.Iterator;

public class IntList implements Iterable<Integer> /* , java.util.List<Integer> */ {
	private final int[] items;
	private int size = 0;
	public IntList( int capacity ){ items = new int[capacity]; }
	public int capacity(){ return items.length; }
	public int size(){ return size; }
	public void add( int value ){
		if( size < items.length ){
			items[size] = value;
			++size;
		} else throw new IllegalStateException();
	}
	public int get( int index ){
		if( 0 <= index && index < size ){
			return items[index];
		} else throw new IllegalArgumentException();
	}
	public void set( int index, int value ){
		if( 0 <= index && index < size ){
			items[index] = value;
		} else throw new IllegalArgumentException();
	}

	public Iterator<Integer> iterator(){
		return new Iterator<Integer>() {
			private int position = 0;
			public boolean hasNext(){ return position < size; }
			public Integer next(){ return items[position++]; }
		};
	}

	public int find( java.util.function.Predicate<Integer> condition ){
		for( int i = 0; i < size; ++i ){
			if( condition.test(items[i]) ){
				return i;
			}
		}
		return -1;
	}

	public static void main( String[] args ){
		IntList mylist = new IntList(10);
		mylist.add(2); mylist.add(3); mylist.add(0);
		int index = mylist.find( x -> x==0 );
		System.out.println(index);
	}
}

